/**
 * \file
 *
 * \brief AVR XMEGAgؓo͐ײ
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include <compiler.h>
#include <status_codes.h>
#include <sleepmgr.h>
#include <sysclk.h>
#include <edma.h>

/**
 * \private
 * \brief EDMAIް\
 */
struct edma_data_struct {
	/** ł̌Ăі߂ */
	edma_callback_t callback;
};

/**
 * \internal
 * \brief eٗpEDMAIް
 */
struct edma_data_struct edma_data[EDMA_MAX_NUMBER_OF_CHANNELS];

/**
 * \brief EDMA틖
 *
 * \note EDMAOɂ̊֐͈ȑȎSĂ̌`Ԑݒ 
 *		 Ăs܂B
 *
 * \param channelmode EDMA_CHMODE_t^ɂė^ٌ`Ԑݒ蓮
 */
void edma_enable(EDMA_CHMODE_t channelmode)
{

	sysclk_enable_module(SYSCLK_PORT_GEN, SYSCLK_EDMA);
	sleepmgr_lock_mode(SLEEPMGR_IDLE);

	/* SĂ0mɂ邽߁APDMAؾ */
	EDMA.CTRL = EDMA_RESET_bm;
	EDMA.CTRL = EDMA_ENABLE_bm | channelmode;
}

/**
 * \brief EDMA֎~
 *
 * \note ̊֐͈ȑȎSĂ̌`ԐݒEDMA֎~܂B
 */
void edma_disable(void)
{
	/* ֎~ */
	EDMA.CTRL = 0x00;
	/* Lҋ@ */
	while (EDMA.CTRL & EDMA_ENABLE_bm) {
	}
	/* S̈ؾ */
	EDMA.CTRL = 0x00;

	sysclk_disable_module(SYSCLK_PORT_GEN, SYSCLK_EDMA);
	sleepmgr_unlock_mode(SLEEPMGR_IDLE);
}

/**
 * \brief ^ꂽEDMAٗpɌĂі߂ݒ
 *
 * \param  num      \ref edma_channel_num_t
 * \param  callback \ref edma_callback_t
 */
void edma_set_callback(edma_channel_num_t num, edma_callback_t callback)
{
	edma_data[num].callback = callback;
}

/**
 * \internal
 * \brief EDMAي荞ݏ
 *
 * ُԕƋٌĂі߂Ăт܂Bȉ̏ԕL蓾܂B
 * - EDMA_CH_TRANSFER_COMPLETED: ɓ]
 * - EDMA_CH_TRANSFER_ERROR: ]s
 *
 * 荞ݏɂĎgpCӑǏĂі߂edma_set_callback()֐
 * ɂĐݒ肳܂B
 *
 * \param  num 荞݂ٔԍ
 */
static void edma_interrupt(const edma_channel_num_t num)
{
	edma_channel_status_t status;
	EDMA_CH_t *channel;

	channel = edma_get_channel_address_from_num(num);
	status  = edma_get_channel_status(num);

	/* ÔߑSĂ̊荞׸ނ */
	channel->CTRLB |= EDMA_CH_TRNIF_bm | EDMA_CH_ERRIF_bm;

	if (edma_data[num].callback) {
		edma_data[num].callback(status);
	}
}

/**
 * \internal
 * \brief EDMA0荞ݏ
 */
ISR(EDMA_CH0_vect)
{
	edma_interrupt(EDMA_CH_0);
}

#if EDMA_MAX_NUMBER_OF_CHANNELS > EDMA_CH_1
/**
 * \internal
 * \brief EDMA1荞ݏ
 */
ISR(EDMA_CH1_vect)
{
	edma_interrupt(EDMA_CH_1);
}
#endif

#if EDMA_MAX_NUMBER_OF_CHANNELS > EDMA_CH_2
/**
 * \internal
 * \brief EDMA2荞ݏ
 */
ISR(EDMA_CH2_vect)
{
	edma_interrupt(EDMA_CH_2);
}
#endif

#if EDMA_MAX_NUMBER_OF_CHANNELS > EDMA_CH_3
/**
 * \internal
 * \brief EDMA3荞ݏ
 */
ISR(EDMA_CH3_vect)
{
	edma_interrupt(EDMA_CH_3);
}
#endif

/**
 * \brief "`Ԑݒ"ϑfEDMAٌ`Ԑݒʰ޳ɏ
 *
 * ̊֐ \ref edma_channel_config ɂĒ񋟂EDMAٌ`Ԑݒ
 * ܂B
 *
 * \param  num    `ԐݒEDMAٔԍ
 * \param  config \ref edma_channel_config ɂė^EDMAٌ`Ԑݒ
 *                ̈ʒuwq
 * \retval edma_channel_config (edma_channel_status_enumB)
 */
edma_channel_status_t edma_channel_write_config(edma_channel_num_t num,
		struct edma_channel_config *config)
{
	/* (WAӋ@\Aps)ٌ^ */
	int8_t std_channel = edma_channel_is_standard(num);
	if (std_channel == -1) {
		return EDMA_CH_UNAVAILABLE;
	}

	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);
	irqflags_t iflags = cpu_irq_save();

	/*  ڽ܂͓]ڽ */
	channel->ADDRL = (uint8_t)(config->addr);
	channel->ADDRH = (uint8_t)((config->addr) >> 8);

	/*  ڽ܂͓]ڽ */
	channel->ADDRCTRL = config->addrctrl;

	/* WقȂ - ]ڽ
	 *              - ]ڽ
	 *              - 16ޯē]v
	 *   Ȃ - 8ޯē]v
	 */
	if (std_channel == 1) {
		channel->DESTADDRL = (uint8_t)(config->destaddr);
		channel->DESTADDRH = (uint8_t)((config->destaddr) >> 8);
		channel->DESTADDRCTRL = config->destaddrctrl;
		channel->TRFCNTL = (uint8_t)(config->trfcnt16);
		channel->TRFCNTH = (uint8_t)((config->trfcnt16) >> 8);
	} else {
		channel->TRFCNTL = config->trfcnt8;
	}

	/* N */
	channel->TRIGSRC = config->trigsrc;

	/* ڼ޽AB
	 * edma_channel_enable()Ă΂OEDMAقĂȂ׸ނ
	 * Ă邱ƂmɂĂB
	 */
	channel->CTRLB = config->ctrlb | (EDMA_CH_ERRIF_bm | EDMA_CH_TRNIF_bm);
	channel->CTRLA = config->ctrla & ~EDMA_CH_ENABLE_bm;

	cpu_irq_restore(iflags);

	return EDMA_CH_READY;
}

/**
 * \brief ʰ޳"`Ԑݒ"ϐEDMAٌ`Ԑݒǂ
 *
 * ̊֐ \ref edma_channel_config EDMAٌ`Ԑݒʰ޳eƓ
 * ܂B
 *
 * \param  num    `ԐݒǂEDMAٔԍ
 * \param  config \ref edma_channel_config ɂė^EDMAٌ`Ԑݒ
 *                ̈ʒuwq
 * \retval edma_channel_config (edma_channel_status_enumB)
 */
edma_channel_status_t edma_channel_read_config(edma_channel_num_t num,
		struct edma_channel_config *config)
{
	/* (WAӋ@\Aps)ٌ^ */
	int8_t std_channel = edma_channel_is_standard(num);
	if (std_channel == -1) {
		return EDMA_CH_UNAVAILABLE;
	}

	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);
	irqflags_t iflags = cpu_irq_save();

	/*  ڽ܂͓]ڽ */
	config->addr  =  ((uint16_t)(channel->ADDRL));
	config->addr |= (((uint16_t)(channel->ADDRH)) << 8);

	/*  ڽ܂͓]ڽ */
	config->addrctrl = channel->ADDRCTRL;

	/* WقȂ - ]ڽ
	 *              - ]ڽ
	 *              - 16ޯē]v
	 *   Ȃ - 8ޯē]v
	 */
	if (std_channel) {
		config->destaddr  =  ((uint16_t)(channel->DESTADDRL));
		config->destaddr |= (((uint16_t)(channel->DESTADDRH)) << 8);
		config->destaddrctrl = channel->DESTADDRCTRL;
		config->trfcnt16  =  ((uint16_t)(channel->TRFCNTL));
		config->trfcnt16 |= (((uint16_t)(channel->TRFCNTH)) << 8);
	} else {
		config->trfcnt8 = channel->TRFCNTL;
	}

	/* N */
	config->trigsrc = channel->TRIGSRC;

	/* ڼ޽AB */
	config->ctrlb = channel->CTRLB;
	config->ctrla = channel->CTRLA;

	cpu_irq_restore(iflags);

	/* ُ܂͓]ԂON */
	if ((config->ctrlb) & EDMA_CH_ERRIF_bm) {
		return EDMA_CH_TRANSFER_ERROR;
	} else if ((config->ctrlb) & EDMA_CH_TRNIF_bm) {
		return EDMA_CH_TRANSFER_COMPLETED;
	}

	/* Z܂͕ۗԂON */
	if ((config->ctrlb) & EDMA_CH_CHBUSY_bm) {
		return EDMA_CH_BUSY;
	} else if ((config->ctrlb) & EDMA_CH_CHPEND_bm) {
		return EDMA_CH_PENDING;
	}

	return EDMA_CH_FREE;
}
