/**
 * \file
 *
 * \brief AVR XMEGAgؓo͐ײޒ`
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef EDMA_H
#define EDMA_H

#include <compiler.h>
#include <interrupt.h>
#include <pmic.h>

/**
 * \defgroup edma_group gؓo͐(EDMA)
 *
 * \ref xmega_edma_quickstartB
 *
 * ߏXMEGAgؓo(EDMA)̌`ԐݒAA֎~Agp
 * ɊւײނłB
 *
 * \section dependencies ˑ
 *
 * gؓo͐ȉ̒PʕɈˑ܂B
 *  - 荞ِݒp \ref pmic_group
 *  - Ӹۯp \ref sysclk_group
 *  - p\ȋx~ݒp \ref sleepmgr_group
 *
 * @{
 */

/** ޲Ɉˑ闘p\EDMAِ */
#define EDMA_MAX_NUMBER_OF_CHANNELS			4
#define EDMA_NUMBER_OF_STANDARD_CHANNELS	2
#define EDMA_NUMBER_OF_PERIPHERAL_CHANNELS	4

/**
 * \private
 * \brief ٔԍŗ^ٕψ(̾)擾 ϸ
 *
 * \param  num EDMAٔԍ
 *
 * \return EDMA_CH_t \a num EDMA ڼ޽\̂ւ̈ʒuwq
 */
#define edma_get_channel_address_from_num(num) \
		((EDMA_CH_t *)((uintptr_t)(&EDMA.CH0) +	\
		(sizeof(EDMA_CH_t) * (uint8_t)num)))

/** \brief EDMAٔԍ */
typedef enum edma_channel_num_enum {
	EDMA_CH_0 = 0,	/**< EDMA0 */
	EDMA_CH_1,		/**< EDMA1 */
	EDMA_CH_2,		/**< EDMA2 */
	EDMA_CH_3,		/**< EDMA3 */
} edma_channel_num_t;

/* W */
typedef enum edma_ch_burstlen_enum {
	EDMA_CH_BURSTLEN_1BYTE_gc = (0x00 << 0),	/*< 1޲ďW */
	EDMA_CH_BURSTLEN_2BYTE_gc = (0x01 << 0),	/*< 2޲ďW */
} edma_ch_burstlen_t;

/** \brief EDMAُ */
typedef enum edma_channel_status_enum {
	EDMA_CH_FREE = 0,			/**< EDMAقͱْ */
	EDMA_CH_READY,				/**< EDMAق͏ċ鏀Ă܂B */
	EDMA_CH_PENDING,			/**< EDMAق͋ĕۗ̉]܂B */
	EDMA_CH_BUSY,				/**< EDMAق͋ĉ]sZłB */
	EDMA_CH_TRANSFER_COMPLETED,	/**< EDMAق͉]܂B */
	EDMA_CH_TRANSFER_ERROR,		/**< EDMAق͉]̊Ɏs܂B */
	EDMA_CH_UNAVAILABLE,		/**< ps\EDMA (AEDMA_CHMODE_STD0_gcłCH1 */
} edma_channel_status_t;

/**
 * \brief EDMAٌ`Ԑݒ\
 */
struct edma_channel_config {
	uint8_t ctrla;			/**< EDMAِڼ޽A */
	uint8_t ctrlb;			/**< EDMAِڼ޽B */
	/** EDMA  ڽڼ޽(Ӌ@\) */
	uint8_t addrctrl;		/**< EDMAٓ]ڽڼ޽(W) */
	uint8_t destaddrctrl;	/**< EDMAٓ]ڽڼ޽(Wق̂)*/
	uint8_t trigsrc;		/**< EDMAًNڼ޽ */
	union {
		uint8_t trfcnt8;	/**< EDMAӋ@\ى]vڼ޽ */
		uint16_t trfcnt16;	/**< EDMAWى]vڼ޽ */
	};
	/** EDMA  16ޯ ڽ(Ӌ@\) */
	uint16_t addr;			/**< EDMAٓ]16ޯ ڽ(W) */
	uint16_t destaddr;		/**< EDMAٓ]16ޯ ڽ(Wق̂) */
	edma_channel_status_t ch_status;	/**< EDMAُ */
};

/** EDMA荞 */
enum edma_int_level_t {
	EDMA_INT_LVL_OFF = 0x00,
	EDMA_INT_LVL_LO  = 0x01,
	EDMA_INT_LVL_MED = 0x02,
	EDMA_INT_LVL_HI  = 0x03,
};

void edma_enable(EDMA_CHMODE_t channelmode);
void edma_disable(void);

/** \name EDMAǗ */
/* @{ */

/**
 * \brief EDMAٗD擮ݒ
 *
 * ̊֐ٗD擮ݒ肵܂Bgp҂͌ŒD挠A׳݁A܂͗
 * ̍IԂƂł܂B
 *
 * \param  primode EDMA_PRIMODE_t^ɂė^EDMAٗD擮
 */
static inline void edma_set_priority_mode(EDMA_PRIMODE_t primode)
{
	irqflags_t iflags;
	iflags = cpu_irq_save();

	EDMA.CTRL = (EDMA.CTRL & ~EDMA_PRIMODE_gm) | primode;

	cpu_irq_restore(iflags);
}

/**
 * \brief EDMA2dɏՓݒ
 *
 * ̊֐2dɏՓɂׂقύX܂B
 *
 * \param  dbufmode EDMA_DBUFMODE_t^ɂė^2dɏٌ`Ԑݒ
 */
static inline void edma_set_double_buffer_mode(EDMA_DBUFMODE_t dbufmode)
{
	irqflags_t iflags;
	iflags = cpu_irq_save();

	EDMA.CTRL = (EDMA.CTRL & ~EDMA_DBUFMODE_gm) | dbufmode;

	cpu_irq_restore(iflags);
}

/** @} */

/** \name EDMAيǗ */
/** @{ */

edma_channel_status_t edma_channel_write_config(edma_channel_num_t num,
		struct edma_channel_config *config);

edma_channel_status_t edma_channel_read_config(edma_channel_num_t num,
		struct edma_channel_config *config);

/**
 * \brief EDMAقWق𒲍
 *
 * ̊֐EDMA`ԐݒɊւEDMAٔԍW܂͎Ӌ@\ق
 * 𒲂ׂ܂B
 *
 * \param  num ₢킹EDMAٔԍ
 *
 * \retval 1  EDMAق͕WقłB
 * \retval 0  EDMAق͎Ӌ@\قłB
 * \retval -1 EDMAٔԍłB
 */
static inline int8_t edma_channel_is_standard(edma_channel_num_t num)
{
	/* ٔԍ */
	if ((num == 1) && ((EDMA.CTRL & EDMA_CHMODE0_bm) == EDMA_CHMODE0_bm)) {
		return -1;
	}

	if ((num == 3) && ((EDMA.CTRL & EDMA_CHMODE1_bm) == EDMA_CHMODE1_bm)) {
		return -1;
	}

	/* ȉȂA͕WقłB
	 * - EDMA_CHMODE_STD02_gcȂAEDMA_CH_2EDMA_CH_0 = W
	 * - EDMA_CHMODE_STD0_gcȂAEDMA_CH_0 = W
	 * - EDMA_CHMODE_STD2_gcȂAEDMA_CH_2 = W
	 * Ȃ΁A͎Ӌ@\قłB
	 */
	if (((EDMA.CTRL & EDMA_CHMODE_gm) == EDMA_CHMODE_STD02_gc) &&
			((num & 1) == 0)) {
		return 1;
	} else if (((EDMA.CTRL & EDMA_CHMODE_gm) == EDMA_CHMODE_STD0_gc) &&
				(num == EDMA_CH_0)) {
		return 1;
	} else if (((EDMA.CTRL & EDMA_CHMODE_gm) == EDMA_CHMODE_STD2_gc) &&
				(num == EDMA_CH_2)) {
		return 1;
	}

	return 0;
}

/**
 * \brief EDMAً
 *
 * ̊֐EDMAق \ref edma_channel_trigger_block_transfer()ŁA܂͑
 * ʰ޳PʕEDMAʰ޳N鎞ɊJn邩̌`ԐݒɉEDMA
 * ق܂B
 *
 * \pre EDMAٌ`ԐݒقOق֏Ȃ΂Ȃ܂B
 *
 * \param  num EDMA
 */
static inline void edma_channel_enable(edma_channel_num_t num)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	irqflags_t iflags = cpu_irq_save();

	channel->CTRLA |= EDMA_CH_ENABLE_bm;

	cpu_irq_restore(iflags);
}

/**
 * \brief EDMAً֎~
 *
 * ̊֐EDMAق֎~܂BEDMAقɋĂꍇAEDMA
 * ق͓]ɏՕEDMA]fOɋ֎~܂B
 *
 * \param  num ֎~EDMA
 */
static inline void edma_channel_disable(edma_channel_num_t num)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	irqflags_t iflags = cpu_irq_save();

	channel->CTRLA &= ~EDMA_CH_ENABLE_bm;

	cpu_irq_restore(iflags);
}

/**
 * \brief EDMAقĂ邩
 *
 * ̊֐EDMAقĂ邩𒲍܂B
 *
 * \param  num ₢킹EDMAٔԍ
 *
 * \retval true  EDMAًĂ܂B
 * \retval false EDMAً֎~Ă܂B
 */
static inline bool edma_channel_is_enabled(edma_channel_num_t num)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	bool channel_enabled = (channel->CTRLA & EDMA_CH_ENABLE_bm)
			>> EDMA_CH_ENABLE_bp;

	return channel_enabled;
}

/**
 * \brief EDMAقZ
 *
 * ̊֐EDMAق]s(ۗ)őZ𒲂ׂ܂B
 *
 * \param  num ₢킹EDMAٔԍ
 *
 * \retval true  EDMAق͑Z܂͕ۗ̉]܂B
 * \retval false EDMAق͑Z܂͉]ۗł͂܂B
 */
static inline bool edma_channel_is_busy(edma_channel_num_t num)
{
	uint8_t busy_pending = EDMA.STATUS;

	busy_pending &= (1 << num) | (1 << (num + 4));
	if (busy_pending) {
		return true;
	}

	return false;
}

/**
 * \brief EDMAُԎ擾
 *
 * ̊֐ُ݂͌ԂԂ܂B
 *
 * \param  num EDMAٔԍ
 *
 * \return \ref edma_channel_statusɂė^ُ
 */
static inline edma_channel_status_t edma_get_channel_status(
		edma_channel_num_t num)
{
	/*
	 * ق̉pԂ߂EDMA`Ԑݒ𒲍Bٌ`𒲂ׂ܂B
	 */
	if ((num == 1) && ((EDMA.CTRL & EDMA_CHMODE0_bm) == EDMA_CHMODE0_bm)) {
		return EDMA_CH_UNAVAILABLE;
	}

	if ((num == 3) && ((EDMA.CTRL & EDMA_CHMODE1_bm) == EDMA_CHMODE1_bm)) {
		return EDMA_CH_UNAVAILABLE;
	}

	uint8_t busy_pending    = EDMA.STATUS;
	uint8_t error_completed = EDMA.INTFLAGS;

	/*
	 * L蓾ُ܂͓]ԂT߂INTFLAGSڼ޽̉ʂƏʂ
	 * ق𒲍
	 */
	error_completed &= (1 << num) | (1 << (num + 4));
	if (error_completed & (1 << (num + 4))) {
		return EDMA_CH_TRANSFER_ERROR;
	} else if (error_completed & (1 << num)) {
		return EDMA_CH_TRANSFER_COMPLETED;
	}

	/*
	 * L蓾鑽Z܂͕ۗԂT߂STATUSڼ޽̉ʂƏʂ
	 * ق𒲍
	 */
	busy_pending &= (1 << num) | (1 << (num + 4));
	if (busy_pending & (1 << (num + 4))) {
		return EDMA_CH_BUSY;
	} else if (busy_pending & (1 << num)) {
		return EDMA_CH_PENDING;
	}

	return EDMA_CH_FREE;
}

/**
 * \brief EDMAقʒuwq擾
 *
 * ̊֐͌̈ʒuwq̒l𓾂邽߂EDMAقǂ݂܂B֐̌
 * ʂްvꏊ̈ʒuwqłB
 *
 * \pre EDMAق͉炩̌ʂ߂ɂpɌ`Ԑݒ肳ċȂ
 *      ΂Ȃ܂B
 *
 * \param  num 삪sEDMAٔԍ
 *
 * \return uint8_t ̌ʂւ̈ʒuwq
 */
static inline uint8_t *edma_channel_get_search_pointer(edma_channel_num_t num)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	uint16_t search_add = (uint16_t)(channel->ADDRL);
	search_add |= (((uint16_t)(channel->ADDRH)) << 8);

	return (uint8_t *)(search_add - 1);
}

/**
 * \brief EDMAق]N
 *
 * ̊֐͗^ꂽEDMAقł̉]̊JnN܂(ĳN)B
 *
 * \pre EDMAق͉炩̌ʂ߂ɂpɌ`Ԑݒ肳ċȂ
 *      ΂Ȃ܂B
 *
 * \param  num ]NEDMٔԍ
 */
static inline void edma_channel_trigger_block_transfer(edma_channel_num_t num)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	irqflags_t iflags = cpu_irq_save();

	channel->CTRLA  |= EDMA_CH_TRFREQ_bm;

	cpu_irq_restore(iflags);
}

/**
 * \brief EDMAقؾ
 *
 * ̊֐͗^ꂽEDMAقؾĂ܂B
 *
 * \param  num ؾĂEDMAٔԍ
 */
static inline void edma_channel_reset(edma_channel_num_t num)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	irqflags_t iflags = cpu_irq_save();

	channel->CTRLA  |= EDMA_CH_RESET_bm;

	cpu_irq_restore(iflags);
}

/**
 * \brief EDMAي荞ݗpĂі߂`
 *
 * \param  status EDMAى]̏
 */
typedef void (*edma_callback_t)(edma_channel_status_t status);

void edma_set_callback(edma_channel_num_t num, edma_callback_t callback);

/** @} */

/**
 * \name EDMAْڌ`Ԑݒ֐
 *
 * ̊֐ \ref edma_channel_config \̂ʂčs킸AEDMAقł̒
 * ڌ`Ԑݒ܂B͍łʓIɕύXEDMAٓ̍XV
 * B
 *
 * @{
 */

/**
 * \brief EDMAُWʰ޳ɏ
 *
 * ̊֐EDMAW𒼐ʰ޳ɏ܂BW*p\ȏW\
 *  \a EDMA_CH_BURSTLEN_*_gc ̌`Œ`܂B
 *
 * \param  num          WEDMAٔԍ
 * \param  burst_length edma_ch_burstlen_t^ŗ^EDMAُW
 */
static inline void edma_channel_write_burst_length(edma_channel_num_t num,
		edma_ch_burstlen_t burst_length)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	irqflags_t iflags = cpu_irq_save();

	channel->CTRLA &= ~EDMA_CH_BURSTLEN_bm;
	channel->CTRLA |= burst_length;

	cpu_irq_restore(iflags);
}

/**
 * \brief EDMAWٓ]8ޯđʰ޳ɏ
 *
 * ̊֐͊e]łEDMAW ޲Đʰ޳ɏ
 *
 * \param  num    ]EDMAWٔԍ
 * \param  count8 e]8ޯ ޲Đ
 */
static inline void edma_channel_write_transfer_count8(edma_channel_num_t num,
		uint8_t count8)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	irqflags_t iflags = cpu_irq_save();

	channel->TRFCNTL = count8;

	cpu_irq_restore(iflags);
}

/**
 * \brief EDMAWٓ]16ޯđʰ޳ɏ
 *
 * ̊֐͊e]łEDMAW ޲Đʰ޳ɏ
 *
 * \param  num     ]EDMAWٔԍ
 * \param  count16 e]16ޯ ޲Đ
 */
static inline void edma_channel_write_transfer_count16(edma_channel_num_t num,
		uint16_t count16)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	irqflags_t iflags = cpu_irq_save();

	channel->TRFCNTL = (uint8_t)count16;
	channel->TRFCNTH = (uint8_t)(count16 >> 8);

	cpu_irq_restore(iflags);
}

/**
 * \brief EDMAٓ]JԂʰ޳ɏ
 *
 * ̊֐EDMAٓ]KԂʰ޳ɏ܂B
 *
 * \param  num    ]JԂEDMAٔԍ
 * \param  repeat ]JԂ
 */
static inline void edma_channel_write_repeat(edma_channel_num_t num,
		bool repeat)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	irqflags_t iflags = cpu_irq_save();

	channel->CTRLA &= ~EDMA_CH_REPEAT_bm;
	channel->CTRLA |=  ((uint8_t)repeat) << EDMA_CH_REPEAT_bp;

	cpu_irq_restore(iflags);
}

/**
 * \brief EDMAӋ@\16ޯ  ڽʰ޳ɏ
 *
 * ̊֐EDMAӋ@\16ޯ  ڽʰ޳ɏ܂B
 *
 * \param  num        16ޯ  ڽEDMAӋ@\ٔԍ
 * \param  memory_add 16ޯ  ڽ
 */
static inline void edma_channel_write_memory_address(edma_channel_num_t num,
		uint16_t memory_add)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	irqflags_t iflags = cpu_irq_save();

	channel->ADDRL = (uint8_t)memory_add;
	channel->ADDRH = (uint8_t)(memory_add >> 8);

	cpu_irq_restore(iflags);
}

/**
 * \brief EDMAӋ@\16ޯē]ڽʰ޳ɏ
 *
 * ̊֐EDMAӋ@\16ޯē]ڽʰ޳ɏ܂B
 *
 * \param  num    16ޯē]ڽEDMAӋ@\ٔԍ
 * \param  source 16ޯē]ڽ
 *
 * static inline void edma_channel_write_src_address(edma_channel_num_t num,
 *          uint16_t source)
 */
#define edma_channel_write_src_address edma_channel_write_memory_address

/**
 * \brief EDMAӋ@\16ޯē]ڽʰ޳ɏ
 *
 * ̊֐EDMAӋ@\16ޯē]ڽʰ޳ɏ܂B
 *
 * \param  num         16ޯē]ڽEDMAWٔԍ
 * \param  destination 16ޯē]ڽ
 */
static inline void edma_channel_write_dest_address(edma_channel_num_t num,
		uint16_t destination)
{
	EDMA_CH_t *channel = edma_get_channel_address_from_num(num);

	irqflags_t iflags = cpu_irq_save();

	channel->DESTADDRL = (uint8_t)destination;
	channel->DESTADDRH = (uint8_t)(destination >> 8);

	cpu_irq_restore(iflags);
}

/** @} */

/** \name EDMAٌ`Ԑݒ߰֐ */
/** @{ */

/**
 * \brief "`Ԑݒ"ϐEDMAُWݒ
 *
 * ̊֐EDMAُWݒ肷Ăяo菕܂BW*p
 * \ȏW\ \a EDMA_CH_BURSTLEN_*_gc ̌`Œ`܂B
 *
 * \param  config       \ref edma_channel_config ϐւ̈ʒuwq
 * \param  burst_length edma_ch_burstlen_t^ɂė^EDMAُW
 */
static inline void edma_channel_set_burst_length(
		struct edma_channel_config *config, edma_ch_burstlen_t burst_length)
{
	config->ctrla &= ~EDMA_CH_BURSTLEN_bm;
	config->ctrla |= burst_length;
}

/**
 * \brief "`Ԑݒ"ϐEDMAْPZ]ݒ
 *
 * ̊֐͒PZ]EDMAقݒ肷Ăяo菕܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 */
static inline void edma_channel_set_single_shot(
		struct edma_channel_config *config)
{
	config->ctrla |= EDMA_CH_SINGLE_bm;
}

/**
 * \brief "`Ԑݒ"ϐEDMAْPZ]
 *
 * ̊֐EDMAْPZ]@\Ăяo菕܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 */
static inline void edma_channel_unset_single_shot(
		struct edma_channel_config *config)
{
	config->ctrla &= ~EDMA_CH_SINGLE_bm;
}

/**
 * \brief "`Ԑݒ"ϐEDMAي荞قݒ
 *
 * ̊֐͓]وُpEDMAي荞قݒ肷Ăяo
 * ܂(ɑ΂ē)B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  level  \ref edma_int_level_t ^ɂė^銄荞
 */
static inline void edma_channel_set_interrupt_level(struct edma_channel_config
		*config, enum edma_int_level_t level)
{
	config->ctrlb &= ~(EDMA_CH_ERRINTLVL_gm | EDMA_CH_TRNINTLVL_gm);
	config->ctrlb |= (level << EDMA_CH_ERRINTLVL_gp) |
			(level << EDMA_CH_TRNINTLVL_gp);
}

/**
 * \brief "`Ԑݒ"ϐEDMAӋ@\  ڽĐݒ蓮ݒ
 *
 * ̊֐EDMAӋ@\  ڽĐݒ蓮ݒ肷Ăяo菕
 * ܂BĐݒ蓮*NONE,BLOCK,BURST,TRANSACTION\
 * \a EDMA_CH_RELOAD_*_gc ̌`° ͯ ̧قŒ`܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  mode   EDMA_CH_RELOAD_t ^ɂė^EDMAӋ@\  
 *                ڽĐݒ蓮
 */
static inline void edma_channel_set_memory_reload_mode(
		struct edma_channel_config *config, EDMA_CH_RELOAD_t mode)
{
	config->addrctrl &= ~EDMA_CH_RELOAD_gm;
	config->addrctrl |=  mode;
}

/**
 * \brief "`Ԑݒ"ϐEDMAWٓ]ڽĐݒ蓮ݒ
 *
 * ̊֐EDMAWٓ]ڽĐݒ蓮ݒ肷Ăяo菕
 * BĐݒ蓮*NONE,BLOCK,BURST,TRANSACTION\ \a EDMA_CH_RELOAD_*_gc
 *  ̌`° ͯ ̧قŒ`܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  mode   EDMA_CH_RELOAD_t ^ɂė^EDMAW ٓ]ڽ
 *                Đݒ蓮
 *
 * static inline void edma_channel_set_src_reload_mode(
 *          struct edma_channel_config *config, EDMA_CH_RELOAD_t mode)
 */
#define edma_channel_set_src_reload_mode edma_channel_set_memory_reload_mode

/**
 * \brief "`Ԑݒ"ϐEDMAWٓ]ڽĐݒ蓮ݒ
 *
 * ̊֐EDMAWٓ]ڽĐݒ蓮ݒ肷Ăяo菕
 * BĐݒ蓮*NONE,BLOCK,BURST,TRANSACTION\ \a EDMA_CH_RELOAD_*_gc
 *  ̌`° ͯ ̧قŒ`܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  mode   EDMA_CH_RELOAD_t ^ɂė^EDMAW ٓ]ڽ
 *                Đݒ蓮
 */
static inline void edma_channel_set_dest_reload_mode(
		struct edma_channel_config *config, EDMA_CH_RELOAD_t mode)
{
	config->destaddrctrl &= ~EDMA_CH_RELOAD_gm;
	config->destaddrctrl |=  mode;
}

/**
 * \brief "`Ԑݒ"ϐEDMAӋ@\  ڽw蓮ݒ
 *
 * ̊֐EDMAӋ@\  ڽw蓮ݒ肷Ăяo菕
 * Bڽw蓮*FIXED,INC,MP1(1޲ĎՕv),MP2(1޲ORv),MP3(2޲
 * Ĉv) \a EDMA_CH_DIR_*_gc ̌`° ͯ ̧قŒ`܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  mode   EDMA_CH_DIR_t ^ɂė^EDMAӋ@\  ڽ
 *                w蓮
 */
static inline void edma_channel_set_memory_dir_mode(
		struct edma_channel_config *config, EDMA_CH_DIR_t mode)
{
	config->addrctrl &= ~EDMA_CH_DIR_gm;
	config->addrctrl |= mode;
}

/**
 * \brief "`Ԑݒ"ϐEDMAWٓ]ڽw蓮ݒ
 *
 * ̊֐EDMAWٓ]ڽw蓮ݒ肷Ăяo菕
 * Bڽw蓮*FIXED܂INC \a EDMA_CH_DIR_*_gc ̌`° 
 * ͯ ̧قŒ`܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  mode   EDMA_CH_DIR_t ^ɂė^EDMAWٓ]ڽw
 *                
 *
 * static inline void edma_channel_set_src_dir_mode(
 *         struct edma_channel_config *config, EDMA_CH_DIR_t mode)
 */
#define edma_channel_set_src_dir_mode edma_channel_set_memory_dir_mode

/**
 * \brief "`Ԑݒ"ϐEDMAӋ@\وvݒ
 *
 * ̊֐EDMAӋ@\وvݒ肷Ăяo菕܂B
 *
 * \note v̏ꍇA \a DIR[1:0] p\ڼ޽̗͎̑̈gp
 *       ܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  mode   EDMA_CH_DIR_t ^ɂė^EDMAӋ@\وv
 *
 * static inline void edma_channel_set_match_mode(
 *        struct edma_channel_config *config, EDMA_CH_DIR_t mode)
 */
#define edma_channel_set_match_mode edma_channel_set_memory_dir_mode

/**
 * \brief "`Ԑݒ"ϐEDMAWٓ]ڽw蓮ݒ
 *
 * ̊֐EDMAWٓ]ڽw蓮ݒ肷Ăяo菕
 * Bڽw蓮*FIXED,INC,MP1(1޲ĎՕv),MP2(1޲ORv),MP3(2޲
 * Ĉv) \a EDMA_CH_DESTDIR_*_gc ̌`° ͯ ̧قŒ`܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  mode   EDMA_CH_DESTDIR_t ^ɂė^EDMAٓ]ڽw
 *                
 */
static inline void edma_channel_set_dest_dir_mode(
		struct edma_channel_config *config, EDMA_CH_DESTDIR_t mode)
{
	config->destaddrctrl &= ~EDMA_CH_DESTDIR_gm;
	config->destaddrctrl |=  mode;
}

/**
 * \brief "`Ԑݒ"ϐEDMAWٌݒ
 *
 * ̊֐EDMAWٌݒ肷Ăяo菕܂B
 *
 * \note ̏ꍇA \a DESTDIR[1:0] p\ڼ޽̗͎̑̈gp
 *       ܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  mode   EDMA_CH_DESTDIR_t ^ɂė^EDMAٌ
 *
 * static inline void edma_channel_set_search_mode(
 *       struct edma_channel_config *config, EDMA_CH_DESTDIR_t mode)
 */
#define edma_channel_set_search_mode edma_channel_set_dest_dir_mode

/**
 * \brief "`Ԑݒ"ϐEDMAًNݒ
 *
 * ̊֐EDMAًNݒ肷Ăяo菕܂BN*lX
 * ȋ\ \a EDMA_CH_TRIGSRC_*_gc ̌`° ͯ ̧قŒ`
 * B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  source EDMA_CH_TRIGSRC_t ^ɂė^ꂽEDMAًN
 */
static inline void edma_channel_set_trigger_source(
		struct edma_channel_config *config, EDMA_CH_TRIGSRC_t source)
{
	config->trigsrc = source;
}

/**
 * \brief "`Ԑݒ"ϐEDMAӋ@\ٓ]ݒ
 *
 * ̊֐͊e]łEDMAӋ@\ ޲Đ(1`256޲)ݒ肷Ăяo
 * 菕܂B
 * \note 256]0x00ɕ܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  count8 e]ł޲Đ
 */
static inline void edma_channel_set_transfer_count8(
		struct edma_channel_config *config, uint8_t count8)
{
	config->trfcnt8 = count8;
}

/**
 * \brief "`Ԑݒ"ϐEDMAWٓ]ݒ
 *
 * ̊֐͊e]łEDMAW ޲Đ(1`65536޲)ݒ肷Ăяo
 * 菕܂B
 * \note 65536]0x0000ɕ܂B
 *
 * \param  config  \ref edma_channel_config ϐւ̈ʒuwq
 * \param  count16 e]ł޲Đ
 */
static inline void edma_channel_set_transfer_count16(
		struct edma_channel_config *config, uint16_t count16)
{
	config->trfcnt16 = count16;
}

/**
 * \brief "`Ԑݒ"ϐEDMAٓ]JԂݒ
 *
 * ̊֐EDMAٓ]JԂݒ肷Ăяo菕܂B
 *
 * \param  config  \ref edma_channel_config ϐւ̈ʒuwq
 */
static inline void edma_channel_set_repeat(struct edma_channel_config *config)
{
	config->ctrla |= EDMA_CH_REPEAT_bm;
}

/**
 * \brief "`Ԑݒ"ϐEDMAٓ]JԂ
 *
 * ̊֐EDMAٓ]JԂĂяo菕܂B
 *
 * \param  config  \ref edma_channel_config ϐւ̈ʒuwq
 */
static inline void edma_channel_unset_repeat(struct edma_channel_config *config)
{
	config->ctrla &= ~EDMA_CH_REPEAT_bm;
}

/**
 * \brief "`Ԑݒ"ϐEDMAӋ@\ 16ޯ  ڽݒ
 *
 * ̊֐EDMAӋ@\  16ޯ ڽݒ肷Ăяo菕
 * B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  source 16ޯ  ڽ
 */
static inline void edma_channel_set_memory_address(
		struct edma_channel_config *config, uint16_t source)
{
	config->addr = source;
}

/**
 * \brief "`Ԑݒ"ϐEDMAW 16ޯē]ڽݒ
 *
 * ̊֐EDMAWٓ]16ޯ ڽݒ肷Ăяo菕܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  source 16ޯē]ڽ
 *
 * static inline void edma_channel_set_source_address(
 *       struct edma_channel_config *config, uint16_t source)
 */
 #define edma_channel_set_source_address edma_channel_set_memory_address

/**
 * \brief "`Ԑݒ"ϐEDMAӋ@\وvްݒ
 *
 * ̊֐EDMAӋ@\وvްݒ肷Ăяo菕܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  data_1 "Օv"pްA܂
 *                "ORv""2޲Č"pް1
 * \param  data_2 "Օv"(ޯĎՕ=1)pՕA܂
 *                "ORv""2޲Č"pް2
 */
static inline void edma_channel_set_match_data(
		struct edma_channel_config *config, uint8_t data_1, uint8_t data_2)
{
	config->addr = (((uint16_t)data_2) << 8) | (uint16_t)data_1;
}

/**
 * \brief "`Ԑݒ"ϐEDMAW 16ޯē]ڽݒ
 *
 * ̊֐EDMAWٓ]16ޯ ڽݒ肷Ăяo菕܂B
 *
 * \param  config      \ref edma_channel_config ϐւ̈ʒuwq
 * \param  destination 16ޯē]ڽ
 */
static inline void edma_channel_set_destination_address(
		struct edma_channel_config *config, uint16_t destination)
{
	config->destaddr = destination;
}

/**
 * \brief "`Ԑݒ"ϐEDMAWٌްݒ
 *
 * ̊֐EDMAWٌްݒ肷Ăяo菕܂B
 *
 * \param  config \ref edma_channel_config ϐւ̈ʒuwq
 * \param  data_1 "Օ"pްA܂
 *                "OR""2޲Č"pް1
 * \param  data_2 "Օ"(ޯĎՕ=1)pՕA܂
 *                "OR""2޲Č"pް2
 */
static inline void edma_channel_set_search_data(
		struct edma_channel_config *config, uint8_t data_1, uint8_t data_2)
{
	config->destaddr = (((uint16_t)data_2) << 8) | (uint16_t)data_1;
}

/** @} */

/** @} */

/**
 * \page xmega_edma_quickstart XMEGA EDMAײޗpJn̎
 *
 * ͎gpʂ̑Iײނ`Ԑݒ肵Ďgp@̒iKIwł 
 * \ref edma_group "EDMAײ" pJn̎łB
 *
 * gpʂ͏̺ޒfЂ܂݂܂B\ݒp̒iK̺ޒfЂ͓Ǝ
 * ɕʂ邱ƂłAgiK͗Ⴆ΁A剞p֐ɕʂ邱
 * ł܂B
 *
 * \section edma_use_cases xȎgp
 * EDMAײނ̍xȎgpɂĂ͈ȉ̎dlʂB
 * - \subpage edma_use_case_1
 * - \subpage edma_use_case_2
 *
 * \section edma_basic_use_case {IȎgp
 * {IȎgpʂ؊ԓ]łB
 * EDMA͈ȉ̂悤Ɍ`Ԑݒ肳܂B
 * - W: 1޲
 * - ]: 100
 * - ]: SRAMɒuꂽɏՕ
 * - ]: SRAMɒuꂽɏՕ
 * - ]Ɠ]̱ڽĐݒ蓮: ̏I
 * - ]Ɠ]̱ڽ: 
 *
 * ̎gpʂް͉̑Sް]܂œ]ɏՕ]ɏՕ
 * 1޲ďWŕʂ܂B̗CPUɑ΂Ĕ񓯊ʰ޳Ŏs 
 * <code>memcpy(destination, source, sizeof(source))</code> ɗގĂ
 * B
 *
 * \section edma_basic_use_case_setup \ݒiK
 *
 * \subsection edma_basic_use_case_setup_prereq OKv
 * ߂ɂ̎gpʂ̍\ݒ躰ނɂāAۼުĂɈȉǉȂ
 * ΂Ȃ܂B
 * -# \ref sysclk_group " ۯǗ޽(sysclk)"
 *
 * \subsection edma_basic_use_case_setup_setup_code ޗ
 * pÇقɒǉĂB
 * \code
 *    #define EDMA_CHMODE      EDMA_CHMODE_STD02_gc
 *    #define EDMA_CHANNEL     EDMA_CH_0
 *    #define EDMA_BUFFER_SIZE 100
 *
 *    static uint8_t source[EDMA_BUFFER_SIZE];
 *    static uint8_t destination[EDMA_BUFFER_SIZE];
 *
 *    static void edma_init(void) {
 *
 *        struct edma_channel_config my_ch_conf;
 *        memset(&my_ch_conf, 0, sizeof(my_ch_conf));
 *
 *        edma_channel_set_burst_length(&my_ch_conf, EDMA_CH_BURSTLEN_1BYTE_gc);
 *        edma_channel_set_transfer_count16(&my_ch_conf, EDMA_BUFFER_SIZE);
 *
 *        edma_channel_set_src_reload_mode(&my_ch_conf,
 *                  EDMA_CH_RELOAD_TRANSACTION_gc);
 *        edma_channel_set_dest_reload_mode(&my_ch_conf,
 *                  EDMA_CH_RELOAD_TRANSACTION_gc);
 *
 *        edma_channel_set_src_dir_mode(&my_ch_conf, EDMA_CH_DIR_INC_gc);
 *        edma_channel_set_dest_dir_mode(&my_ch_conf, EDMA_CH_DESTDIR_INC_gc);
 *
 *        edma_channel_set_source_address(&my_ch_conf,
 *                  (uint16_t)source);
 *        edma_channel_set_destination_address(&my_ch_conf,
 *                  (uint16_t)destination);
 *
 *        edma_channel_set_trigger_source(&my_usart_ch_conf,
 *                  EDMA_CH_TRIGSRC_OFF_gc);
 *
 *        edma_enable(EDMA_CHMODE);
 *
 *        edma_channel_write_config(EDMA_CHANNEL, &my_ch_conf);
 *        edma_channel_enable(EDMA_CHANNEL);
 *
 *    }
 * \endcode
 *
 * \c main()ɒǉĂB
 * \code
 * sysclk_init();
 * edma_init();
 * \endcode
 *
 * \subsection edma_basic_use_case_setup_flow Ƃ̗
 * -# ݒ肷EDMAٓ`܂B
 *   - \code #define EDMA_CHMODE EDMA_CHMODE_STD02_gc \endcode
 * -# ]ɎgpEDMAWق`܂B
 *   - \code #define EDMA_CHANNEL EDMA_CH_0 \endcode
 * -# SRAMɒu]Ɠ]̊ɏՕɎgpz񒷂`܂B
 *   - \code #define EDMA_BUFFER_SIZE 100 \endcode
 * -# NꂽEDMAقɂĕʂ]Ɠ]ްێ
 *    Sz̑΂쐬܂B
 *   - \code
 * static uint8_t source[EDMA_BUFFER_SIZE];
 * static uint8_t destination[EDMA_BUFFER_SIZE];
 *     \endcode
 * -# EDMA邽߂ \c edma_init() ֐쐬܂B
 *     - \code
 * static void edma_init(void) {
 *     // ...
 * }
 *       \endcode
 * -# EDMAٗp`Ԑݒ\̂쐬܂B
 *   - \code struct edma_channel_config my_ch_conf; \endcode
 * -# VlOɑSĂ̒l̊ؾĂ̂ۏ؂邽߂Ɍ`
 *    Ԑݒ\̂0ݒ肳邱ƂmɂĂB
 *   - \code memset(&my_ch_conf, 0, sizeof(my_ch_conf)); \endcode
 * -# ]Ɠ]̊ɏՕ̑傫Ɠ]ŒP޲ē]pEDMAق
 *    `Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_burst_length(&my_ch_conf, EDMA_CH_BURSTLEN_1BYTE_gc);
 * edma_channel_set_transfer_count16(&my_ch_conf, EDMA_BUFFER_SIZE);
 *     \endcode
 * -# ]̍Ō(A \c EDMA_BUFFER_SIZE ޲ĕʌ)]Ɠ]̱ڽ
 *    ؾĂ悤EDMAق`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_src_reload_mode(&my_ch_conf, EDMA_CH_RELOAD_TRANSACTION_gc);
 * edma_channel_set_dest_reload_mode(&my_ch_conf,
 *         EDMA_CH_RELOAD_TRANSACTION_gc);
 *     \endcode
 * -# e޲ē]ɓ]Ɠ]̱ڽ𑝉悤EDMAق`Ԑݒ肵
 *    B
 *   - \code
 * edma_channel_set_src_dir_mode(&my_ch_conf, EDMA_CH_DIR_INC_gc);
 * edma_channel_set_dest_dir_mode(&my_ch_conf, EDMA_CH_DESTDIR_INC_gc);
 *     \endcode
 * -# EDMAق̓]Ɠ]̱ڽ`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_source_address(&my_ch_conf, (uint16_t)source);
 * edma_channel_set_destination_address(&my_ch_conf, (uint16_t)destination);
 *     \endcode
 * -# EDMAقɑ΂NƂĿĳw߂ݒ肵܂B
 *   - \code
 * edma_channel_set_trigger_source(&my_usart_ch_conf, EDMA_CH_TRIGSRC_OFF_gc);
 *     \endcode
 * -# őSĂق`Ԑݒ肷EDMAPʕ܂B̏ꍇAEDMA
 *    EDMA_CH_0EDMA_CH_2̕Wق悤ɐݒ肳܂B 
 *    <code>EDMA_CHMODE_STD02_gc</code> `ԐݒɑΉ܂B
 *      - \code edma_enable(EDMA_CHMODE); \endcode
 *  \attention Calling edma_enable() will result in a soft-reset of the entire
 *             EDMA module, clearing all channel configurations. If more than
 *             one EDMA channel is to be configured, this function should be
 *             called only once in the application initialization procedure
 *             only.
 * -# ]JnN邱Ƃł悤EDMAʰ޳`Ԑݒ肵Ă
 *    悤EDMAٌ`Ԑݒ܂B
 *   - \code
 * edma_channel_write_config(EDMA_CHANNEL, &my_ch_conf);
 * edma_channel_enable(EDMA_CHANNEL);
 *     \endcode
 * -# ۯ т܂B
 *      - \code sysclk_init(); \endcode
 * -# EDMA֐Ăт܂B
 *      - \code edma_init(); \endcode
 *
 * \section edma_basic_use_case_usage giK
 *
 * \subsection edma_basic_use_case_usage_code ޗ
 * Ⴆ΁ApÇٓ̎JԂɒǉĂB
 * \code
 *    edma_channel_trigger_block_transfer(EDMA_CHANNEL);
 *    do {} while (edma_get_channel_status(EDMA_CHANNEL) !=
 *                EDMA_CH_TRANSFER_COMPLETED);
 * \endcode
 *
 * \subsection edma_basic_use_case_usage_flow Ƃ̗
 * -# EDMA]Jn邽߂̿ĳw
 *   - \code edma_channel_trigger_block_transfer(EDMA_CHANNEL); \endcode
 * -# ]ҋ@
 *   - \code do {} while (edma_get_channel_status(EDMA_CHANNEL) !=
 *                       EDMA_CH_TRANSFER_COMPLETED);
 *     \endcode
 */

/**
 * \page edma_use_case_1 gp#1 - Ӌ@\قp؂Ӌ@\ւ
 * EDMA]
 *
 * ̎gpʂ͎弽 ؂ƎӋ@\قpӋ@\Ԃł̏WEDMA]̍\
 * ݒ@܂B
 *
 * ̎gpʂłEDMAȉ̂悤Ɍ`Ԑݒ肳܂B
 * - W: 1޲
 * - ]: ]ɏՕɈˑ
 * - ]: RAMɒuꂽɏՕ
 * - ]: RS232USARTC0
 * - ]ڽĐݒ蓮: ̏I
 * - ]ڽ: 
 * - ]N: USARTް ڼ޽(DRE)
 *
 * ̎gpʂްUSARTް ڼ޽̓xRAM̊ɏՕUSARTɕ
 * ܂B̗"ر"޽ <code>usart_serial_write_packet()</code> 
 * ɗގĂ܂B
 *
 * \section edma_use_case_1_setup \ݒiK
 *
 * \subsection edma_use_case_setup_prereq OKv
 * ߂̂̎gpʂ̍\ݒ躰ނɂāAۼުĂɈȉǉȂ
 * ΂Ȃ܂B
 * -# \ref sysclk_group " ۯǗ޽(sysclk)"
 * -# \ref usart_group "USARTײ"
 *
 * USARTXMEGA USARTײޑJn \ref xmega_usart_quickstart "{IȎgp
 * " ɏ]Č`Ԑݒ肳Ȃ΂Ȃ܂B
 *
 * \subsection edma_use_case_1_setup_code ޗ
 * pÇقɒǉĂB
 * \code
 *    #define EDMA_CHMODE      EDMA_CHMODE_STD0_gc
 *    #define EDMA_CHANNEL     3
 *
 *    static uint8_t usart_string[] = "XMEGAE5 EDMA-USART print test.\r\n";
 *
 *    static void edma_init(void)
 *    {
 *        struct edma_channel_config my_ch_conf;
 *        memset(&my_ch_conf, 0, sizeof(my_ch_conf));
 *        uint8_t string_size = sizeof(usart_string);
 *
 *        edma_channel_set_burst_length(&my_ch_conf, EDMA_CH_BURSTLEN_1BYTE_gc);
 *        edma_channel_set_transfer_count8(&my_ch_conf, string_size);
 *
 *        edma_channel_set_memory_reload_mode(&my_ch_conf,
 *                  EDMA_CH_RELOAD_TRANSACTION_gc);
 *
 *        edma_channel_set_memory_dir_mode(&my_ch_conf, EDMA_CH_DIR_INC_gc);
 *
 *        edma_channel_set_memory_address(&my_ch_conf,
 *              (uint16_t)usart_string);
 *
 *        edma_channel_set_trigger_source(&my_ch_conf,
 *                  EDMA_CH_TRIGSRC_USARTC0_DRE_gc);
 *
 *        edma_channel_set_single_shot(&my_ch_conf);
 *
 *        edma_enable(EDMA_CHMODE);
 *
 *        edma_channel_write_config(EDMA_CHANNEL, &my_ch_conf);
 *        edma_channel_enable(EDMA_CHANNEL);
 *    }
 * \endcode
 *
 * \c main()ɒǉĂB
 * \code
 * #define USART    &USARTC0
 * static usart_rs232_options_t USART_OPTIONS = {
 *      .baudrate   = 19200,
 *      .charlength = USART_CHSIZE_8BIT_gc,
 *      .paritytype = USART_PMODE_DISABLED_gc,
 *      .stopbits   = false
 * };
 * sysclk_init();
 * usart_init_rs232(USART, &USART_OPTIONS);
 * edma_init();
 * \endcode
 *
 *
 * \subsection edma_use_case_1_setup_flow Ƃ̗
 * -# ݒ肳EDMAٓ`܂B̏ꍇAEDMA1̕Wق
 *    EDMA_CH_02̎Ӌ@\قEDMA_CH_2EDMA_CH_3悤ɐݒ肳
 *    B
 *   - \code #define EDMA_CHMODE EDMA_CHMODE_STD0_gc \endcode
 * -# ֗USART]ɎgpEDMAӋ@\ق`܂B
 *   - \code #define EDMA_CHANNEL 3 \endcode
 * -# 镶ێSz쐬܂B
 *   - \code
 * static uint8_t usart_string[] = "XMEGAE5 EDMA-USART print test.\r\n";
 *     \endcode
 * -# EDMA邽߂ \c edma_init() ֐쐬܂B
 *     - \code
 * static void edma_init(void)
 * {
 *     // ...
 * }
 *       \endcode
 * -# EDMAp`Ԑݒ\̂쐬܂B
 *   - \code struct edma_channel_config my_ch_conf; \endcode
 * -# VlOɑSĂ̒l̊ؾĂ̂ۏ؂邽߂Ɍ`
 *    Ԑݒ\̂0ݒ肳邱ƂmɂĂB
 *   - \code memset(&my_ch_conf, 0, sizeof(my_ch_conf)); \endcode
 * -# RAMɒuꂽ؊ɏՕɎgpz񒷂𓾂܂B
 *   - \code uint8_t string_size = sizeof(usart_string); \endcode
 * -# <code>usart_string[]</code> ؊ɏՕ̑傫Ɠ]EDMAقP
 *    ޲ďWɌ`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_burst_length(&my_ch_conf, EDMA_CH_BURSTLEN_1BYTE_gc);
 * edma_channel_set_transfer_count8(&my_ch_conf, string_size);
 *     \endcode
 * -# ̍Ō(A \c string_size ޲ĕʌ) ڽؾĂ悤
 *    EDMAق`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_memory_reload_mode(&my_ch_conf,
 *         EDMA_CH_RELOAD_TRANSACTION_gc);
 *     \endcode
 * -# e޲ē] ڽ𑝉悤EDMAق`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_memory_dir_mode(&my_ch_conf, EDMA_CH_DIR_INC_gc);
 *     \endcode
 * -# EDMA  ڽ`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_memory_address(&my_ch_conf, (uint16_t)usart_string);
 *     \endcode
 * -# EDMAقɑ΂NƂUSART C0ް ڼ޽ݒ肵܂B
 *   - \code
 * edma_channel_set_trigger_source(&my_ch_conf, EDMA_CH_TRIGSRC_USARTC0_DRE_gc);
 *     \endcode
 * -# Nx1޲ďW]s悤EDMAقPɌ`Ԑݒ
 *    ܂B
 *   - \code edma_channel_set_single_shot(&my_ch_conf); \endcode
 * -# őSĂق`Ԑݒ肷EDMAPʕ܂B̏ꍇAEDMA1
 *    ̕WقEDMA_CH_02̎Ӌ@\قEDMA_CH_2EDMA_CH_3悤
 *    ɐݒ肳܂B
 *    <code>EDMA_CHMODE_STD0_gc</code> configuration:
 *      - \code edma_enable(EDMA_CHMODE); \endcode
 *  \attention Calling edma_enable() will result in a soft-reset of the entire
 *             EDMA module, clearing all channel configurations. If more than
 *             one EDMA channel is to be configured, this function should be
 *             called only once in the application initialization procedure
 *             only.
 * -# ]̊JnN邱Ƃł悤EDMAʰ޳EDMAٌ`Ԑݒ
 *    Ă܂B
 *   - \code
 * edma_channel_write_config(EDMA_CHANNEL, &my_ch_conf);
 * edma_channel_enable(EDMA_CHANNEL);
 *     \endcode
 * -# ǂUSARTgp邩`܂B
 *   - \code #define USART &USARTC0 \endcode
 * -# USART\̂`Ė܂B
 *   - \code
 * static usart_rs232_options_t USART_OPTIONS = {
 *      .baudrate   = 19200,
 *      .charlength = USART_CHSIZE_8BIT_gc,
 *      .paritytype = USART_PMODE_DISABLED_gc,
 *      .stopbits   = false
 * };
 *     \endcode
 * -# ۯ т܂B
 *      - \code sysclk_init(); \endcode
 * -# USART܂B
 *      - \code usart_init_rs232(USART, &USART_OPTIONS); \endcode
 * -# EDMA֐Ăт܂B
 *      - \code edma_init(); \endcode
 *
 * \section edma_use_case_1_usage giK
 *
 * \subsection edma_use_case_1_usage_code ޗ
 * Ⴆ΁ApÇقŎJԂɒǉĂB
 * \code
 *    do {} while (edma_get_channel_status(EDMA_CHANNEL) !=
 *                EDMA_CH_TRANSFER_COMPLETED);
 * \endcode
 *
 * \subsection edma_use_case_1_usage_flow Ƃ̗
 * -# ]ҋ@
 *   - \code
 * do {} while (edma_get_channel_status(EDMA_CHANNEL) !=
 *             EDMA_CH_TRANSFER_COMPLETED);
 *     \endcode
 */

/**
 * \page edma_use_case_2 ×z#2 - Ӌ@\ƕWR̍gp
 * Ӌ@\ւEDMA](؊ɏՕ͕Wقł̌@\pčs
 * B)
 *
 * ̎dlʂ͍ŏ̗ؓl@ǍɎӋ@\قp
 * Ď弽 ؂ƎӋ@\ԂŏWEDMA]\ݒ肷̂ɂgp@
 * ܂B
 *
 * ̎gpʂłEDMAȉ̂悤Ɍ`Ԑݒ肳܂B
 * - W: 1޲
 * - ]: "ް"EDMA@\gp
 * - ]: RAMɒuꂽɏՕ
 * - ]: RS232USARTC0
 * - ]ڽĐݒ蓮: ̍Ō
 * - ]ڽ: 
 * - ]N: USARTް ڼ޽(DRE)
 *
 * ̎gpʂްASCIIOłBASCII͏0x00ɂďI
 * ܂BEDMAްUSARTް ڼ޽̓xRAMASCII񂩂USART
 * ]()邽߂̊ɏՕݒ肵܂B̗"stdio"ײ؂ 
 * <code>printf(usart_string)</code> ֐ƗގĂ܂B
 *
 * \section edma_use_case_2_setup \ݒiK
 *
 * \subsection edma_use_case_setup_prereq OKv
 * ߂̍\ݒ躰ނɂāAۼުĂɈȉǉȂ΂Ȃ܂B
 * -# \ref sysclk_group " ۯǗ޽(sysclk)"
 * -# \ref usart_group "USARTײ"
 *
 * USART \ref xmega_usart_quickstart "{IȎgp" XMEGA USARTײޑ
 * Jnɏ]Č`Ԑݒ肳Ȃ΂Ȃ܂B
 *
 * \subsection edma_use_case_2_setup_code ޗ
 * pÇقɒǉĂB
 * \code
 *    #define EDMA_CHMODE            EDMA_CHMODE_STD0_gc
 *    #define EDMA_USART_CHANNEL     2
 *    #define EDMA_SEARCH_CHANNEL    0
 *    #define EDMA_SEARCH_PATTERN    0x00
 *
 *    static uint8_t usart_string[] = "XMEGAE5 EDMA-USART print test.\r\n";
 *
 *    static uint8_t edma_search_data(void)
 *    {
 *        struct edma_channel_config my_search_ch_conf;
 *        memset(&my_search_ch_conf, 0, sizeof(my_search_ch_conf));
 *
 *        edma_channel_set_burst_length(&my_search_ch_conf,
 *                  EDMA_CH_BURSTLEN_1BYTE_gc);
 *        edma_channel_set_transfer_count16(&my_search_ch_conf, 255);
 *
 *        edma_channel_set_src_reload_mode(&my_search_ch_conf,
 *                  EDMA_CH_RELOAD_NONE_gc);
 *
 *        edma_channel_set_src_dir_mode(&my_search_ch_conf, EDMA_CH_DIR_INC_gc);
 *        edma_channel_set_search_mode(&my_search_ch_conf, EDMA_CH_DIR_MP1_gc);
 *
 *        edma_channel_set_source_address(&my_search_ch_conf,
 *                  (uint16_t)usart_string);
 *        edma_channel_set_search_data(&my_search_ch_conf,
 *                  EDMA_SEARCH_PATTERN, 0xFF);
 *
 *        edma_channel_set_trigger_source(&my_search_ch_conf,
 *                  EDMA_CH_TRIGSRC_OFF_gc);
 *
 *        edma_channel_write_config(EDMA_SEARCH_CHANNEL, &my_search_ch_conf);
 *        edma_channel_enable(EDMA_SEARCH_CHANNEL);
 *        edma_channel_trigger_block_transfer(EDMA_SEARCH_CHANNEL);
 *
 *        do {} while (edma_get_channel_status(EDMA_SEARCH_CHANNEL) !=
 *                  EDMA_CH_TRANSFER_COMPLETED);
 *
 *        edma_channel_read_config(EDMA_SEARCH_CHANNEL, &my_search_ch_conf);
 *
 *        return ((uint8_t)(my_search_ch_conf.addr -
 *                         (uint16_t)usart_string)
 *                         - 1);
 *    }
 *
 *    static void edma_usart_init(uint8_t string_size)
 *    {
 *        struct edma_channel_config my_usart_ch_conf;
 *        memset(&my_usart_ch_conf, 0, sizeof(my_usart_ch_conf));
 *
 *        edma_channel_set_burst_length(&my_usart_ch_conf,
 *                  EDMA_CH_BURSTLEN_1BYTE_gc);
 *        edma_channel_set_transfer_count8(&my_usart_ch_conf, string_size);
 *
 *        edma_channel_set_memory_reload_mode(&my_usart_ch_conf,
 *                  EDMA_CH_RELOAD_TRANSACTION_gc);
 *
 *        edma_channel_set_memory_dir_mode(&my_usart_ch_conf,
 *                  EDMA_CH_DIR_INC_gc);
 *
 *        edma_channel_set_memory_address(&my_usart_ch_conf,
 *                  (uint16_t)usart_string);
 *
 *        edma_channel_set_trigger_source(&my_usart_ch_conf,
 *                  EDMA_CH_TRIGSRC_USARTC0_DRE_gc);
 *
 *        edma_channel_set_single_shot(&my_usart_ch_conf);
 *
 *        edma_channel_write_config(EDMA_USART_CHANNEL, &my_usart_ch_conf);
 *        edma_channel_enable(EDMA_USART_CHANNEL);
 *    }
 * \endcode
 *
 * \c main()ɒǉĂB
 * \code
 * #define USART    &USARTC0
 * static usart_rs232_options_t USART_OPTIONS = {
 *      .baudrate   = 19200,
 *      .charlength = USART_CHSIZE_8BIT_gc,
 *      .paritytype = USART_PMODE_DISABLED_gc,
 *      .stopbits   = false
 * };
 * sysclk_init();
 * usart_init_rs232(USART, &USART_OPTIONS);
 * edma_enable(EDMA_CHMODE);
 * edma_usart_init(edma_search_data());
 * \endcode
 *
 * \subsection edma_use_case_2_setup_flow Ƃ̗
 * -# ݒ肳EDMAٓ`܂B̏ꍇAEDMA1̕Wق
 *    EDMA_CH_02̎Ӌ@\قEDMA_CH_2EDMA_CH_3悤ɐݒ肳
 *    B
 *   - \code #define EDMA_CHMODE EDMA_CHMODE_STD0_gc \endcode
 * -# ֗USART]ɎgpEDMAӋ@\ق`܂B
 *   - \code #define EDMA_USART_CHANNEL 2 \endcode
 * -# ASCII̍Ō}镶(0x00)̂ɎgpEDMAW
 *    `܂B
 *   - \code #define EDMA_SEARCH_CHANNEL 0 \endcode
 * -# ̂߂̕(܂͗l)`܂B
 *   - \code #define EDMA_SEARCH_PATTERN 0x00 \endcode
 * -# 邽߂̕ێSz쐬܂B
 *   - \code
 * static uint8_t usart_string[] = "XMEGAE5 EDMA-USART print test.\r\n";
 *     \endcode
 * -# ̍Ō邽߂ \c edma_search_data() ֐쐬܂B
 *    ֐(̍Ō̕)̑傫Ԃ܂B
 *     - \code
 * static uint8_t edma_search_data(void)
 * {
 *     // ...
 * }
 *       \endcode
 * -# ɎgpEDMAٗp`Ԑݒ\̂쐬܂B
 *   - \code struct edma_channel_config my_search_ch_conf; \endcode
 * -# VlOɑSĂ̒l̊ؾĂ邱Ƃۏ؂邽߂
 *    `Ԑݒ\̂0ݒ肳邱ƂmɂĂB
 *   - \code memset(&my_search_ch_conf, 0, sizeof(my_search_ch_conf)); \endcode
 * -# (USART]Ɏgp)Ӌ@\قƂłő̑傫ɑΉ
 *    255̍őEDMAقP޲ďWɌ`Ԑݒ肵܂B0͌EȂ̂
 *    ߁AIlɂȂ蓾܂B
 *   - \code
 * edma_channel_set_burst_length(&my_search_ch_conf, EDMA_CH_BURSTLEN_1BYTE_gc);
 * edma_channel_set_transfer_count16(&my_search_ch_conf, 255);
 *     \endcode
 * -# ̍Ōœ]ڽؾĂȂ悤EDMAق`Ԑݒ肵܂B
 *    ͕̍Ō̕ʒuwq𓾂邽߂ɕKvłB]Đݒ蓮
 *    ͕svłB
 *   - \code
 * edma_channel_set_src_reload_mode(&my_search_ch_conf, EDMA_CH_RELOAD_NONE_gc);
 *     \endcode
 * -# e޲Ĕr ڽ𑝉悤EDMAق`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_src_dir_mode(&my_search_ch_conf, EDMA_CH_DIR_INC_gc);
 *     \endcode
 * -# EDMAقɂĎs錟`Ԑݒ肵܂B̏ꍇA 
 *    <code>EDMA_CH_DIR_MP1_gc<\code> ɂĒ`"Օ"łB
 *   - \code
 * edma_channel_set_search_mode(&my_search_ch_conf, EDMA_CH_DIR_MP1_gc);
 *     \endcode
 * -# EDMAٓ]ڽ`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_source_address(&my_search_ch_conf, (uint16_t)usart_string);
 *     \endcode
 * -# ްƎՕݒ肵܂(SՕ=0xFF)B
 *   - \code
 * edma_channel_set_search_data(&my_search_ch_conf, EDMA_SEARCH_PATTERN, 0xFF);
 *     \endcode
 * -# EDMAٗp̋NƂĿĳw߂ݒ肵܂B
 *   - \code
 * edma_channel_set_trigger_source(&my_search_ch_conf, EDMA_CH_TRIGSRC_OFF_gc);
 *     \endcode
 * -# JnNł悤EDMAʰ޳EDMAٌ`ԐݒĂ
 *    ܂B
 *   - \code
 * edma_channel_write_config(EDMA_SEARCH_CHANNEL, &my_search_ch_conf);
 * edma_channel_enable(EDMA_SEARCH_CHANNEL);
 *     \endcode
 * -# EDMAJn邽߂̿ĳw
 *   - \code edma_channel_trigger_block_transfer(EDMA_CHANNEL); \endcode
 * -# Iҋ@
 *   - \code
 * do {} while (edma_get_channel_status(EDMA_SEARCH_CHANNEL) !=
 *                  EDMA_CH_TRANSFER_COMPLETED);
 *     \endcode
 * -# sꂽEDMAٌ`Ԑݒ̂߂EDMAʰ޳ǂ݂܂B
 *   - \code
 * edma_channel_read_config(EDMA_SEARCH_CHANNEL, &my_search_ch_conf);
 *     \endcode
 * -# Ō̕(̍Ō)̍lȂŕ̑傫vZĕԂ܂B
 *    character (end of string):
 *   - \code
 * return ((uint8_t)(my_search_ch_conf.addr - (uint16_t)usart_string) - 1);
 *     \endcode
 *
 * -# EDMAoRUSART]邽߂ \c edma_usart_init() ֐쐬
 *    B̑傫ҰƂēn܂B
 *     - \code
 * static void edma_usart_init(uint8_t string_size)
 * {
 *     // ...
 * }
 *       \endcode
 * -# USART]gpEDMAٗp`Ԑݒ\̂쐬܂B
 *   - \code struct edma_channel_config my_usart_ch_conf; \endcode
 * -# VlOɑSĂ̒l̊ؾĂ邱Ƃۏ؂邽߂
 *    `Ԑݒ\̂0ݒ肳邱ƂmɂĂB
 *   - \code memset(&my_usart_ch_conf, 0, sizeof(my_usart_ch_conf)); \endcode
 * -# RAMɒuꂽ؊ɏՕɎgpz񒷂𓾂܂B
 *   - \code uint8_t string_size = sizeof(usart_string); \endcode
 * -# ҰƂēnꂽ̑傫ɓ]EDMAقP޲ďW
 *    Ɍ`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_burst_length(&my_usart_ch_conf, EDMA_CH_BURSTLEN_1BYTE_gc);
 * edma_channel_set_transfer_count8(&my_usart_ch_conf, string_size);
 *     \endcode
 * -# ̍Ō(A \c string_size ޲Ăʂꂽ) ڽؾ
 *    悤EDMAق`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_memory_reload_mode(&my_usart_ch_conf,
 *                  EDMA_CH_RELOAD_TRANSACTION_gc);
 *     \endcode
 * -# e޲ē] ڽ𑝉悤EDMAق`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_memory_dir_mode(&my_usart_ch_conf, EDMA_CH_DIR_INC_gc);
 *     \endcode
 * -# EDMA  ڽ`Ԑݒ肵܂B
 *   - \code
 * edma_channel_set_memory_address(&my_usart_ch_conf, (uint16_t)usart_string);
 *     \endcode
 * -# EDMAٗp̋NƂUSART C0ް ڼ޽ݒ肵܂B
 *   - \code
 * edma_channel_set_trigger_source(&my_usart_ch_conf,
 *                  EDMA_CH_TRIGSRC_USARTC0_DRE_gc);
 *     \endcode
 * -# ꂪN閈1W]s悤EDMAقPɌ`
 *    Ԑݒ肵܂B
 *   - \code edma_channel_set_single_shot(&my_usart_ch_conf); \endcode
 * -# ]JnN邱Ƃł悤EDMAٌ`ԐݒEDMAʰ޳ɏĂ
 *    ܂B
 *   - \code
 * edma_channel_write_config(EDMA_USART_CHANNEL, &my_usart_ch_conf);
 * edma_channel_enable(EDMA_USART_CHANNEL);
 *     \endcode
 * -# ǂUSARTgp邩`܂B
 *   - \code #define USART &USARTC0 \endcode
 * -# USART\̂`Ė܂B
 *   - \code
 * static usart_rs232_options_t USART_OPTIONS = {
 *      .baudrate   = 19200,
 *      .charlength = USART_CHSIZE_8BIT_gc,
 *      .paritytype = USART_PMODE_DISABLED_gc,
 *      .stopbits   = false
 * };
 *     \endcode
 * -# ۯ т܂B
 *      - \code sysclk_init(); \endcode
 * -# USART܂B
 *      - \code usart_init_rs232(USART, &USART_OPTIONS); \endcode
 * -# őSق`Ԑݒ肷EDMAPʕ܂B̏ꍇAEDMA1̕W
 *    قEDMA_CH_02̎Ӌ@\قEDMA_CH_2EDMA_CH_3悤ɐ
 *    肳܂B <code>EDMA_CHMODE_STD0_gc</code> `Ԑݒɏ]܂B
 *      - \code edma_enable(EDMA_CHMODE); \endcode
 *  \attention Calling edma_enable() will result in a soft-reset of the entire
 *             EDMA module, clearing all channel configurations. If more than
 *             one EDMA channel is to be configured, this function should be
 *             called only once in the application initialization procedure
 *             only.
 * -# Ƃ( <code>edma_search_data()<\code> ֐̖߂l)̑傫
 *    n <code>edma_usart_init()<\code> ֐Ăт܂B
 *      - \code edma_usart_init(edma_search_data()); \endcode
 *
 * \section edma_use_case_2_usage giK
 *
 * \subsection edma_use_case_2_usage_code ޗ
 * Ⴆ΁ApÇقŎJԂɒǉĂB
 * \code
 *    do {} while (edma_get_channel_status(EDMA_USART_CHANNEL) !=
 *                  EDMA_CH_TRANSFER_COMPLETED);
 * \endcode
 *
 * \subsection edma_use_case_2_usage_flow Ƃ̗
 * -# ]ҋ@
 *   - \code
 * do {} while (edma_get_channel_status(EDMA_USART_CHANNEL) !=
 *                  EDMA_CH_TRANSFER_COMPLETED);
 *     \endcode
 */

#endif /* EDMA_H */
