/**
 * \file
 *
 * \brief DALI]uMڰя
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include <avr/eeprom.h>
#include "dali_hal.h"
#include "dali_frame.h"
#include "dali_cmd.h"
#include "dali_top.h"

#define SPECIAL_CMD_LOW		TERMINATE
#define SPECIAL_CMD_HIGH	WRITE_MEMORY_LOCATION

/* ڽ` */
#define NOT_ME				0x00
#define GROUP_ADDR			0x01
#define BROADCAST			0x02
#define SHORT_ADDR			0x03
#define SPECIAL_CMD			0x04

/* ڰтŎgp鎞 */
#define BEFORE_FORWARD_FRAMES_TIME	(22 * DALI_FRAME_DECODE_TICK)
#define BEFORE_BACKWARD_FRAME_TIME	(12 * DALI_FRAME_DECODE_TICK)
#define REPETITION_110MS			(264 * DALI_FRAME_DECODE_TICK)

/* ڰёM */
enum {IDLE, FORWARD_FRAME, FORWARD_BACKWARD_DELAY, FORWARD_IDLE_DELAY,
      FORWARD_REPEAT_FRAME, FORWARD_REPEAT_DELAY,
      BACKWARD_FRAME_ANSWER, BACKWARD_IDLE_DELAY};

extern uint8_t eeprom_short_address EEMEM;
extern uint8_t eeprom_group_0_7 EEMEM;
extern uint8_t eeprom_group_8_15 EEMEM;

uint8_t data_backup;
uint8_t frame_state;
dali_slave_service_info_t service_info;

uint8_t dali_frame_check_addr(dali_slave_service_info_t *slave_info);
uint8_t dali_frame_process_data(dali_slave_service_info_t *slave_info,
		uint8_t addr_type, bool repeat_flag);

void dali_frame_init(void)
{
	dali_cmd_init();
	frame_state = IDLE;
}

void dali_frame_process_state(void)
{
	uint8_t addr_type;
	switch (frame_state) {
	case IDLE:
		frame_state = FORWARD_FRAME;
		service_info.get_new_frame = false;
		dali_hal_disable_frame_timer_interrupt();

		break;

	case FORWARD_FRAME:
		if (service_info.get_new_frame == true) {
			dali_hal_enable_frame_timer_interrupt();
			service_info.frame_time = 0;
			service_info.get_new_frame = false;
			addr_type = dali_frame_check_addr(&service_info);
			if (addr_type != NOT_ME) {
				frame_state = dali_frame_process_data(
						&service_info, addr_type, false);
			}

			if (frame_state == FORWARD_BACKWARD_DELAY) {
				dali_hal_forward_decode_disable();
			}
		}

		break;

	case FORWARD_REPEAT_FRAME:
		if ((service_info.frame_time < REPETITION_110MS) &&
				(service_info.frame_time >= BEFORE_FORWARD_FRAMES_TIME)) {
			if (service_info.get_new_frame == true) {
				service_info.get_new_frame = false;
				addr_type = dali_frame_check_addr(&service_info);
				if (addr_type != NOT_ME) {
					if (data_backup ==	service_info.rec_data) {
						dali_frame_process_data(&service_info, addr_type, true);
						frame_state = IDLE;
					} else {
						/* ԂŖ߂𑗂ꍇ */
						frame_state	= FORWARD_REPEAT_DELAY;
					}
				}
			}
		} else if (service_info.frame_time >= REPETITION_110MS) {
			frame_state = IDLE;
		}

		break;

	case FORWARD_REPEAT_DELAY:
		if (service_info.frame_time >= REPETITION_110MS) {
			frame_state = IDLE;
		}

		break;

	case FORWARD_BACKWARD_DELAY:
		if (service_info.frame_time >= BEFORE_BACKWARD_FRAME_TIME) {
			/* tڰъJn */
			service_info.send_status = SENDING_START;
			frame_state = BACKWARD_FRAME_ANSWER;
		}

		break;

	case BACKWARD_FRAME_ANSWER:
		if (service_info.send_status == SENDING_STOP) {
			service_info.frame_time = 0;
			frame_state = BACKWARD_IDLE_DELAY;
		}

		break;

	case FORWARD_IDLE_DELAY:
	case BACKWARD_IDLE_DELAY:
		if (service_info.frame_time >= BEFORE_FORWARD_FRAMES_TIME) {
			if (frame_state == BACKWARD_IDLE_DELAY)	{
				dali_hal_forward_decode_enable();
			}
			frame_state = IDLE;
		}

		break;

	default:
		break;
	}
}

/**
 *  \brief DALIڽ`
 *
 *  \param  slave_info DALIԏ\̂ւ̈ʒuwq
 *
 *  \returns ڽ`
 *
 */
uint8_t dali_frame_check_addr(dali_slave_service_info_t *slave_info)
{
	uint8_t temp;
	/* Q܂͈ıڽ */
	if (slave_info->rec_addr & ADDR_Y) {
		if ((slave_info->rec_addr & ADDR_NON_SHORT) == 0) {
			/* Qڽ 0`15 */
			temp = (slave_info->rec_addr & ADDR_GROUP_A) >> 1;
			if (temp < 8) {
				if(eeprom_read_byte(&eeprom_group_0_7) & (1 << temp)) {
					return GROUP_ADDR;
				}
			} else {
				if(eeprom_read_byte(&eeprom_group_8_15) & (1 << (temp - 8))) {
					return GROUP_ADDR;
				}
			}
		} else if ((slave_info->rec_addr & ADDR_BROADCAST) ==
				ADDR_BROADCAST) {
			return BROADCAST;
		} else if ((slave_info->rec_addr >= SPECIAL_CMD_LOW) &&
				(slave_info->rec_addr <= SPECIAL_CMD_HIGH)) {
			return SPECIAL_CMD;
		}
	} else if ((slave_info->rec_addr & ADDR_SHORT_A) ==
			(eeprom_read_byte(&eeprom_short_address) << 1)) {
		return SHORT_ADDR;
	}
	return NOT_ME;
}

/**
 *  \brief DALIڽƖ߂̏B߂ɏ]Frame_stateύXׂłB
 *
 *  \param  slave_info  DALIԏ\̂ւ̈ʒuwq
 *  \param  addr_type   ڽ`w
 *  \param  repeat_flag `Ԑݒ薽߂̌JԂw
 *                      (false:ŏ̎MAtrue: 2ڂ̎M)
 *
 *  \returns ڰя
 *
 */
uint8_t dali_frame_process_data(dali_slave_service_info_t *slave_info,
		uint8_t addr_type, bool repeat_flag)
{
	uint8_t ret = FORWARD_IDLE_DELAY;
	uint16_t response;

	if (slave_info->rec_addr & ADDR_S) {
		if (addr_type == SPECIAL_CMD) {
			response = dali_cmd_process_special(slave_info, repeat_flag);
		} else {
			response = dali_cmd_process_normal(slave_info, repeat_flag);
		}

		if (response == RECEIVE_FIRST) {
			data_backup = slave_info->rec_data;
			ret = FORWARD_REPEAT_FRAME;
		} else if (response != ANSWER_NO) {
			slave_info->send_data = (uint8_t)response;
			ret = FORWARD_BACKWARD_DELAY;
		}

	} else if (addr_type != SPECIAL_CMD) {
		dali_cmd_direct_arc_power_control(slave_info->rec_data);
	}
	return ret;
}

void dali_slave_set_addr_to_service(uint8_t address)
{
	service_info.rec_addr = address;
}

void dali_slave_set_data_to_service(uint8_t data)
{
	service_info.rec_data = data;
}

uint8_t dali_slave_get_send_status_from_service(void)
{
	return service_info.send_status;
}

void dali_slave_set_send_status_to_service(uint8_t status)
{
	service_info.send_status = status;
}

void dali_slave_frame_time_inc(void)
{
	service_info.frame_time++;
}

void dali_slave_set_frame_flag_to_service(bool flag)
{
	service_info.get_new_frame = flag;
}

uint8_t dali_slave_get_send_data_from_service(void)
{
	return service_info.send_data;
}